program RR;

uses
  Forms,
  SysUtils,
  Dialogs,
  LMDnonVS,
  ResRen in 'ResRen.pas' {Form1};

{$R *.RES}
const
    WAIT_TIME : TDateTime = 0.001; // about 3 minutes
    DELAY_TIME : TDateTime = 0.0001; // about 10 seconds
var
      sr : TSearchRec;
      path, newName : string;
      pPos, sPos : integer;
      prog : TLMDStarter;

      procedure DeleteExisting( const newName : string );
      var sr : TSearchRec;
          startWaiting : TDateTime;
      begin
           if FindFirst( newName, faAnyFile, sr ) = 0 then begin
              startWaiting := time();
              while ( not DeleteFile(newName) )
                and ( time() <= (startWaiting + WAIT_TIME) ) do
                    Application.ProcessMessages(); // just wait until we can
              if time() >= startWaiting + WAIT_TIME then
                 ShowMessage( 'Cannot delete ' + newName + ' to allow the renaming' );
           end;
      end;
      procedure DelayAWhile;
      var startDelay : TDateTime;
      begin
         startDelay := time();  // give some time for the delete/rename to happen
         while ( time() <= (startDelay + DELAY_TIME) ) do
             Application.ProcessMessages(); // just wait
      end;
begin
  Application.Initialize;
  Application.Title := 'Rename and Restart';
  Application.CreateForm(TForm1, Form1);
  if ParamCount < 1 then
      ShowMessage( 'Usage: RR <scan path> <exe name>' )
  else
  begin
      DelayAWhile;
      pPos := LastDelimiter( '\:', ParamStr(1) );
      sPos := Pos( '*', ParamStr(1) );
      path := Copy( ParamStr(1), 1, pPos );
      if FindFirst(ParamStr(1), faAnyFile, sr) = 0 then
          repeat
              if (sr.Attr and faDirectory) = 0 then
              begin
                  newName := Path + Copy( sr.Name, sPos-pPos, Length(sr.Name) - (sPos-pPos) + 1 );
                  deleteExisting( newName );
                  if not RenameFile( Path + sr.Name, newName ) then
                     ShowMessage( 'Cannot rename ' + Path + sr.Name + ' to ' + newName );
              end;
          until ( FindNext(sr) <> 0 );
      DelayAWhile;
      if ParamCount = 2 then begin
         prog := TLMDStarter.Create(Form1);
         prog.Command := ParamStr(2);
         prog.DefaultDir := Path;
         prog.Execute;
         prog.Free;
      end;
  end;
end.
