{ Main form for UpdateSFXstub

  Copyright (c) 2001 Roland Ruder (info@rolandr.de).
  Freeware: May be freely distributed and modified. Use at your own risk.
  This program draws heavily on

    - the units from Gregory L. Bullock (bullock@tsppd.net)

    - the aDiff unit, copyright (c) 1997 S.Kurinny & S.Kostinsky

    - the Lh5Unit unit, which had various contributers, as noted in its
      source code

  If you fix any bugs or make significant enhancements, I ask you to send
  your modifications to Gregory L. Bullock and a cc to me.

}

unit UnitSFX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  DoUpdate, StdCtrls, Forms, Dialogs;

type
  TFormUpdateSFX = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure MakeTmpFile;
    procedure ChkTmpFile;
    procedure MakeUpdate;
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormUpdateSFX: TFormUpdateSFX;

implementation

{$R *.DFM}

const
  SFXlength = 96256; (*this value is *wrong* for you and has to be changed after recompiling!!!
  
  SFXlenght=220160; is the size of the compiled updatesfxstup.exe with german D2, must be changed.
  SFXlength=357376; is the size of the compiled updatesfxstup.exe with german D5, that's why I prefer D2.
  You should compress the compiled exefile-stub with UPX, then check it's size and change
  the SFXlength to the new value and recompile it. Finally compress with UPX again.

  The value above is only right for german D2 after "UPXing" ;-)

  Then create a self-extracting-UpdateSFX with the DOS-Command:
  copy /b updatesfxstup.exe + updatefilename.upd UpdateSFX.EXE
  where "updatefilename.upd" has to be a valid UPDfile, made with MakeUPD from Greg L. Bullock.

  The end-user of your UpdateSFX.EXE has to copy it into the folder to be updated and then run it.

  Maybe Greg or me will implement a function to create UpdateSFXs from within MakeUPD.
  *)
  BUFSIZE = 8192;
  COUNT: LONGINT = 0;

var
  fromMe, updFileName: string;
  BUFFER: array[1..BUFSIZE] of BYTE;


procedure TFormUpdateSFX.FormCreate(Sender: TObject);
begin
  Height := 24; //just show a small caption or
  //Left:=-200; Top:=-200; //don't show form on screen
  if MessageBox(Handle, 'Do you want to run the update?', 'UpdateSFX', mb_YesNo or mb_IconQuestion or mb_DefButton1)
    <> id_Yes then halt;
  updFileName := ExtractFilePath(Paramstr(0)) + '~eraseme.tmp';
  //the stub will create this temporary updfile from itself, cutting off the SFXlength
  fromMe := paramstr(0);
  //the stub with the attached updfile
end;

procedure TFormUpdateSFX.FormShow(Sender: TObject);
begin
  MakeTmpFile;
end;

procedure TFormUpdateSFX.MakeTmpFile;
(*extract and create temporary updfile from exefile*)
var
  InFile, OutFile: file;
  FSIZE: LONGINT;
  DRESULT: DWORD;
begin
  COUNT := 0;
  AssignFile(InFile, FromMe);
  FileMode := 0; // read only
(*$I-*) RESET(InFile, 1); (*$I+*)
  if ioresult <> 0 then
  begin
    MessageBox(0, 'Could not open UpdateSFX.', 'Error', mb_IconStop);
    close;
  end;
  seek(InFile, SFXlength); // seek the update-data after the exefile-stub
  FileMode := 2; // read and write
  AssignFile(OutFile, UPDFileName);
(*$I-*) REWRITE(OutFile, 1); (*$I+*)
  if ioresult <> 0 then
  begin
    MessageBox(0, 'Could not create temporary file.', 'Error', mb_IconStop);
    CloseFile(InFile);
    close;
  end;

  repeat
    FileMode := 0;
    BLOCKREAD(InFile, BUFFER, BUFSIZE, DRESULT);
    FileMode := 2;
    BLOCKWRITE(OutFile, BUFFER, DRESULT);
    INC(COUNT, DRESULT);
  until (COUNT = FSIZE) or (DRESULT <> BUFSIZE);
  CloseFile(OutFile);
  CloseFile(InFile);

  ChkTmpFile;
end;

procedure TFormUpdateSFX.ChkTmpFile;
begin
  if not fileexists(updFileName) then
  begin
    MessageBox(0, 'Temporary file not found.', 'Error', mb_IconStop);
    close;
  end;
  MakeUpdate;
end;

procedure TFormUpdateSFX.MakeUpdate;
begin
  ApplyUpdateFile(updFileName);
  DeleteFile(updFileName);
  close;
end;


end.

