unit createsfx_unit;

interface

uses SysUtils, Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  TSFXAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SFXAboutBox: TSFXAboutBox;

implementation

uses mkSFX;

const
  StubName: string = 'UpdateSFXStub.EXE'; //has to be changed

{$R *.DFM}

procedure TSFXAboutBox.FormCreate(Sender: TObject);
begin
  StubName := extractfilepath(paramstr(0)) + StubName;
end;

procedure TSFXAboutBox.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TSFXAboutBox.FormShow(Sender: TObject);
var
  UpdName, ExeName : string;
begin
  if opendialog1.execute then
    UpdName := Opendialog1.FileName else exit;
  savedialog1.FileName := ChangeFileExt(UpdName, '.exe');
  if savedialog1.execute then
  begin
    ExeName := savedialog1.FileName;
    if ExeName = paramstr(0) then exit;
    if ExeName = stubname then exit;
    if MakeSFXFile(StubName, UpdName, ExeName) then
      MessageBox(Handle, 'The SFX-Update-Program was created successfully.', 'Create SFX', mb_IconInformation) else
    begin
      MessageBox(Handle, 'Could not create the SFX-Update-Program.', 'Create SFX', mb_IconStop);
      close;
    end;
  end;
end;

end.

